//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------
#include "enemy.h"


void inicializarEnemigo(Tenemy* ene,u8 x,u8 y,u8 vida,u8* mapa,u8 nmap,u8 arriba,WayPoint* point,u8 path,u8 floor){
	u8 i=0;
	ene-> x = ene->px = x;
	ene-> y = ene->py = y;
	ene-> mover = 0;
	ene-> sprite = SPRITESENEMIGOUP;
	ene-> vida = vida;
	ene-> mapa = mapa;
	ene-> state = 0;
	ene-> antState = 0;  
	ene-> locationMap=nmap;
	ene-> dir=1; //El enemigo se inicializa mirando siempre hacia arriba
	ene-> patrolPosition = point;
	ene-> arriba = arriba;
	ene-> dirpat = 0;	
	ene-> patrollpath = path;
	ene-> NSEWstate = 0;
	ene-> delay = TIEMPO_DELAY;
	ene->auxX = ene->auxY = 0;
	ene->floor = floor;
}

void moveLeftEnemy(Tenemy* ene) __z88dk_fastcall {
	if (ene->x > 0 && comprobarMovimentoLeftEnemy(ene)){
		ene->dir=4;
		ene-> sprite = SPRITESENEMIGOLEFT;
		ene->x--;
		ene->mover = SI;
	}else if(ene->x == 0 ){

	}else{

	}
}

void moveRightEnemy(Tenemy* ene) __z88dk_fastcall {
	if( ene->x < LIMITE_DERECHO_ENEMY){
		if (comprobarMovimentoRightEnemy(ene)){
			ene->dir=2;
			ene-> sprite = SPRITESENEMIGORIGHT;
			ene->x++;
			ene->mover = SI;
		}

	} else{

	}
}

void moveUpEnemy(Tenemy* ene) __z88dk_fastcall {
	if(ene->y > 1 && comprobarMovimentoUpEnemy(ene)){
		ene->dir=1;
		ene-> sprite = SPRITESENEMIGOUP;
		ene->y--;
		ene->y--;
		/*ene->y--;
		ene->y--;*/
		ene->mover = SI;
	}else{

	}
}

void moveDownEnemy(Tenemy* ene) __z88dk_fastcall {
    if(ene->y < LIMITE_INFERIOR_ENEMY && comprobarMovimentoDownEnemy(ene)){
    	ene->dir=3;
    	ene-> sprite = SPRITESENEMIGODOWN;
		ene->y++;
		ene->y++;
	/*	ene->y++;
		ene->y++;*/
		ene->mover = SI;
	}else{

	}
}

u8* obtenerTilePtrEnemy(Tenemy* ene,u8 x, u8 y) {
   return ene->mapa + (y-40)/4*40 + x/2;
}

u8 comprobarMovimentoLeftEnemy(Tenemy* ene) __z88dk_fastcall {
	u8* tileSuelo = obtenerTilePtrEnemy(ene,ene->x-1, ene->y);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtrEnemy(ene,ene->x-1, ene->y+G_ENEMIGOS_0_H-1);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
		return 0;
	}
}

u8 comprobarMovimentoRightEnemy(Tenemy* ene) __z88dk_fastcall {
	u8* tileSuelo = obtenerTilePtrEnemy(ene,ene->x+G_ENEMIGOS_0_W, ene->y);
	if(*tileSuelo == PARED){
		 u8* aux = obtenerTilePtrEnemy(ene,ene->x+G_ENEMIGOS_0_W, ene->y+G_ENEMIGOS_0_H-1);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
		return 0;
	}
}

u8 comprobarMovimentoUpEnemy(Tenemy* ene) __z88dk_fastcall {
	u8* tileSuelo = obtenerTilePtrEnemy(ene,ene->x, ene->y-2);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtrEnemy(ene,ene->x+G_ENEMIGOS_0_W-1, ene->y-2);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
		return 0;
	}
}

u8 comprobarMovimentoDownEnemy(Tenemy* ene) __z88dk_fastcall {
	u8* tileSuelo = obtenerTilePtrEnemy(ene,ene->x, ene->y+G_ENEMIGOS_0_H+1);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtrEnemy(ene,ene->x+G_ENEMIGOS_0_W-1, ene->y+G_ENEMIGOS_0_H);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
		return 0;
	}
}

/*void moveRandom(Tenemy* ene,u8 nmapa){
	u8 random_number;
	if(ene->locationMap == nmapa){
		cpct_srand(ene->seed);
		random_number = cpct_rand();
		if(random_number > 0 && random_number < 64)
		{
			moveDownEnemy(ene);
		}
		else if(random_number >= 64 && random_number < 128)
		{
			moveUpEnemy(ene);
		}
		else if(random_number >= 128 && random_number < 192)
		{
			moveRightEnemy(ene);
		}
		else if(random_number >= 192 && random_number <= 255)
		{
			moveLeftEnemy(ene);
		}
		ene->seed++;
	}
}*/


//Copia un punto B a uno A
void copyPoint(Point2D* a, Point2D* b){
	a->x=b->x;
	a->y=b->y;
}