#ifndef _ENEMY_H
#define _ENEMY_H
#include <cpctelera.h>
#include "enemigos.h"
#include "map1.h"
#include "map2.h"


#define NO 0
#define SI 1
#define PARED 0
#define SPRITESENEMIGOUP g_enemigos_0
#define SPRITESENEMIGODOWN g_enemigos_2
#define SPRITESENEMIGOLEFT g_enemigos_3
#define SPRITESENEMIGORIGHT g_enemigos_1
#define G_SPRITESENEMIGO_W G_ENEMIGOS_0_W
#define G_SPRITESENEMIGO_H G_ENEMIGOS_0_H
#define ANCHO_PANTALLA_ENEMY 80
#define ALTO_PANTALLA_ENEMY  200
#define LIMITE_DERECHO_ENEMY ANCHO_PANTALLA_ENEMY - G_SPRITESENEMIGO_W
#define LIMITE_INFERIOR_ENEMY ALTO_PANTALLA_ENEMY - G_SPRITESENEMIGO_H
#define TIEMPO_DELAY 20;
//estructura de los waypoits
typedef struct WayPoint WayPoint;
struct WayPoint{
   u8      x,y;
   WayPoint* pre;
   WayPoint* sig;
   };
//estructura de puntos X e Y
typedef struct Point2D Point2D;
struct Point2D
{
	u8 x,y;
};

//estructura de enemigo
typedef struct Tenemy Tenemy;
struct Tenemy{
   u8        x,y;
   u8        px,py;
   const u8*       sprite;
   u8        mover;
   u8        vida;
   u8*       mapa;
   u8        dir;  //Dirección en la que mira el enemigo 
   // 1 Arriba          1
   // 2 Derecha      4  E  2
   // 3 Abajo           3
   // 4 Izquierda    
   u8        state;
   u8        antState;     //para saver en que estado estaba anteriormente
   u8        locationMap;
   WayPoint* patrolPosition;
   u8        patrollpath;   //indica que patrulla siguen a = 0 ,b = 1,c = 2 etc.... 
   u8        arriba;       //si esta a 1 esta en los mapas aarriba si esta a 0 esta en los de abajo   
   u8        dirpat;       //si esta a 0 hace la patrulla al derecho, si no al revés
   u8        NSEWstate;    //estado en NSEW
   u8        delay;        //tiempo de retraso entre estados
   u8        auxX,auxY;    //variables para controlar que el enemigo se queda atascado
   u8        floor;        //para controlar la planta 
};



void inicializarEnemigo(Tenemy*,u8,u8,u8,u8*,u8,u8,WayPoint*,u8,u8);
//void moveRandom(Tenemy*,u8);
void moveLeftEnemy(Tenemy*) __z88dk_fastcall ;
void moveRightEnemy(Tenemy*) __z88dk_fastcall ;
void moveUpEnemy(Tenemy*) __z88dk_fastcall ;
void moveDownEnemy(Tenemy*) __z88dk_fastcall ;
u8* obtenerTilePtrEnemy(Tenemy*,u8, u8);
u8 comprobarMovimentoLeftEnemy(Tenemy* ene) __z88dk_fastcall ;
u8 comprobarMovimentoRightEnemy(Tenemy* ene) __z88dk_fastcall ;
u8 comprobarMovimentoUpEnemy(Tenemy* ene) __z88dk_fastcall ;
u8 comprobarMovimentoDownEnemy(Tenemy* ene) __z88dk_fastcall ;
void copyPoint(Point2D* a, Point2D* b);                  //Copia el punto B al punto A

#endif
