//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------
#include "ia.h"

extern WayPoint a1,b1,a18;
//------------------------------------------------------------------------------------------------------------------------------------------//
//Comportamiento enemigo																													//
//------------------------------------------------------------------------------------------------------------------------------------------//

//Me devuelve SI si está en mi campo de visión
u8 loVeo(TJugador* prota, Tenemy* enemy){
    u8 resultado;
    u8* tiledVisto;
	if(prota->state){// Si el prota es invisible
		return NO;
	}
	switch(enemy->dir){
		case 2:
			//----------------------------------------------------------------------------------------------------------------------------------------------//
			//		  ___
			//		 |X X|		El enemigo ve 2 cuadros en el eje X y 5 cuadros en el eje Y, dos a su izquierda, dos a su derecha y el que tiene en frente	//
			//		E|X X|
			//		 |X X|		El enemigo no ve a sus lados ni detrás de él mismo a no ser de que cambie de dirección										//
			//		  ¯¯¯
			//----------------------------------------------------------------------------------------------------------------------------------------------//
			
			//Si el enemigo mira a la derecha
				if(prota->x > enemy->x + (G_SPRITESENEMIGO_W*3)){										//En el caso de que esté fuera de su campo de vision por delante
				resultado = NO;
				}
				else if (prota->x+ G_SPRITESJUGADORES_1_W < enemy->x){									//En el caso de que esté fuera de su campo de vision por detrás
					return NO;
				}
				else{	//En el caso de que esté dentro de su campo de visión en el eje X
					if (prota->y+ G_SPRITESJUGADORES_1_H < enemy->y - G_SPRITESENEMIGO_H){				//En el caso de que esté fuera de su campo de vision por arriba
						return NO;
					}
					else if(prota->y > enemy->y + (G_SPRITESENEMIGO_H*3)){								//En el caso de que esté fuera de su campo de vision por abajo
						return NO;
					}
					else{//SÍ está en su campo de visión
						//putero enemy, x e y
						//resultado = SI;
						tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_SPRITESENEMIGO_W+G_HALFSPRITESENEMIGO_W , enemy->y + G_HALFSPRITESENEMIGO_H);
						if(*tiledVisto != PARED){
							resultado = NO;
						}else{
							tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_SPRITESENEMIGO_W + G_HALFSPRITESENEMIGO_W*3 , enemy->y + G_HALFSPRITESENEMIGO_H);
							if(*tiledVisto != PARED){
								resultado = NO;
							}
							else{
								resultado = SI;
							}
							
						}
					}
				}
			break;
		case 1:
			//-----------//
			//  _______  //
			// | X X X | //
			// |_______| //
			//     E     //
			//-----------//

			//Si el enemigo mira arriba
				if(prota->x > enemy->x +(G_SPRITESENEMIGO_W*2)){										//En caso de que esté fuera de su campo de vision por la derecha
					return NO;
				}
				else if(prota->x+G_SPRITESJUGADORES_1_W < enemy->x - G_SPRITESENEMIGO_W){				//En caso de que esté fuera de su campo de visión por la izquierda
					return NO;
				}
				else{
					if(prota->y + G_SPRITESJUGADORES_1_H < enemy->y- (G_SPRITESENEMIGO_H*3)){			//En caso de que esté fuera de su campo de visión por delante
						return NO;
					}
					else if( prota->y > enemy->y){														//En caso de que esté fuera de su campo de visión por detrás
						return NO;
					}
					else{//SÍ está en su campo de visión
					   //resultado = SI;
						//putero enemy, x e y
						tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_HALFSPRITESENEMIGO_W, enemy->y + G_HALFSPRITESENEMIGO_H);
						if(*tiledVisto != PARED){
							resultado = NO;
						}else{
							tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_HALFSPRITESENEMIGO_W, enemy->y + G_SPRITESENEMIGO_H );
							if(*tiledVisto != PARED){
								resultado = NO;
							}else{
								resultado = SI;
							}
								
						}
					}

				}
			break;
		case 4:
			//-----------//
			//	  ___	 //
			//	 |X X|	 //	
			//	 |X X|E  //
			//	 |X X|	 //	
			//	  ¯¯¯	 //
			//-----------//

			//Si el enemigo mira a la izquierda
				if(prota->x > enemy->x){																//En el caso de que esté fuera de su campo de vision por detrás
					return NO;
				}
				else if(prota->x+ G_SPRITESJUGADORES_1_W < enemy->x - (G_SPRITESENEMIGO_W*2)){ 			//En el caso de que esté fuera de su campo de vision por delante
				resultado = NO;
				}
				else{//En el caso de que esté dentro de su campo de visión en el eje X
					if (prota->y+ G_SPRITESJUGADORES_1_H < enemy->y - G_SPRITESENEMIGO_H){				//En el caso de que esté fuera de su campo de vision por arriba
						return NO;
					}
					else if(prota->y > enemy->y + (G_SPRITESENEMIGO_H*3)){								//En el caso de que esté fuera de su campo de vision por abajo
						return NO;
					}
					else{//SÍ está en su campo de visión
						//resultado = SI;
						//putero enemy, x e y
						tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x - G_HALFSPRITESENEMIGO_W , enemy->y + G_HALFSPRITESENEMIGO_H);
						if(*tiledVisto != PARED){
							resultado = NO;
						}else{
							tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x - G_HALFSPRITESENEMIGO_W*3 , enemy->y + G_HALFSPRITESENEMIGO_H);
							if(*tiledVisto != PARED){
								resultado = NO;
							}
							else{
								resultado = SI;
							}
							
						}
					
					}
				}
			break;
		case 3:
			//-----------//
			//  ___E___  //
			// | X X X | //
			// |_______| //
			//           //
			//-----------//
			
			//Si el enemigo mira abajo
				if(prota->x > enemy->x +(G_SPRITESENEMIGO_W*2)){										//En caso de que esté fuera de su campo de vision por la derecha
					return NO;
				}
				else if(prota->x+G_SPRITESJUGADORES_1_W < enemy->x - G_SPRITESENEMIGO_W){				//En caso de que esté fuera de su campo de visión por la izquierda
					return NO;
				}
				else{
					if(prota->y > enemy->y +(G_SPRITESENEMIGO_H*4)){									//En caso de que esté fuera de su campo de visión por delante
					resultado = NO;
					}
					else if(prota->y + G_SPRITESJUGADORES_1_H < enemy->y){								//En caso de que esté fuera de su campo de visión por detrás
						return NO;
					}
					else{//SÍ está en su campo de visión
					//resultado = SI;
						//putero enemy, x e y
						tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_HALFSPRITESENEMIGO_W, enemy->y + G_SPRITESENEMIGO_H + G_HALFSPRITESENEMIGO_H);
						if(*tiledVisto != PARED){
							resultado = NO;
						}else{
							tiledVisto=obtenerTilePtrEnemy(enemy,enemy->x + G_HALFSPRITESENEMIGO_W, enemy->y + G_SPRITESENEMIGO_H + G_HALFSPRITESENEMIGO_H*2);
							if(*tiledVisto != PARED){
								resultado = NO;
							}else{
								resultado = SI;
							}
								
						}
					}
				}
			break;
		default:
			resultado = NO;
			break;
	}
	return resultado;

}

//Lo persigue cuando todavía lo puede ver
//Si se entra a este módulo es que ya lo ha visto
void persecucion(TJugador* prota, Tenemy* enemy,u8* mapa){
	cpct_waitVSYNC();
	if(loVeo(prota,enemy)){//Si lo veo, voy a por el
		if(enemy->dir == 1){
			moveUpEnemy(enemy);
		}
		else if(enemy->dir == 2){
			moveRightEnemy(enemy);
		}
		else if(enemy->dir == 3){
			moveDownEnemy(enemy);
		} 
		else if(enemy->dir == 4){
			moveLeftEnemy(enemy);
		}
		//REPINTA
		if(enemy->mover){
			redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
			enemy->mover=NO;
		}
		
	}
	else{//Busco dónde se puede haber ido
		if(enemy->locationMap == prota->locationMap){//Si el prota no se ha largao
			enemy->state = 3;
			enemy->antState = 1;
		}
	}
}

//Busca en las cuatro direcciones cuando lo pierde de vista
//Solo entrará aqui si el prota no ha salido del mapa
void buscaNSEWConDelay(TJugador* prota, Tenemy* enemy,u8* mapa){
	cpct_waitVSYNC();
	if(loVeo(prota,enemy)){
		enemy->state = 1;
		//persecucion(prota,enemy,mapa);
	}else{

	if(enemy->NSEWstate == 0){
		enemy->dir=1;								//Busca por arriba
		enemy-> sprite = SPRITESENEMIGOUP;
		enemy->mover=SI;
		enemy->NSEWstate = 1;
		//REPINTA
		if(enemy->mover){
			cpct_waitVSYNC();
		redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
		enemy->mover=NO;
		}
		
	}
	else if(--enemy->delay == 0){
	//espero el tiempo para cambiar la posicion 

	if(enemy->NSEWstate == 1 ){
		//recargo el temporaizador 
		enemy->delay = TIEMPO_DELAY;
		enemy->NSEWstate = 2;
		enemy->dir=2;							//Busca por la derecha
		enemy-> sprite = SPRITESENEMIGORIGHT;
		enemy->mover=SI;
		
		//REPINTA
		if(enemy->mover){
			cpct_waitVSYNC();
			redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
			enemy->mover=NO;
		}
		


	}
	else if(enemy->NSEWstate == 2 ){
		//recargo el temporaizador 
		enemy->delay = TIEMPO_DELAY;
		enemy->NSEWstate = 3;
		enemy->dir=3;							//Busca por la derecha
		enemy-> sprite = SPRITESENEMIGODOWN;
		enemy->mover=SI;

		//REPINTA
		if(enemy->mover){
			cpct_waitVSYNC();
			redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
			enemy->mover=NO;
		}
		


	}
	else if(enemy->NSEWstate == 3 ){
		//recargo el temporaizador 
		enemy->delay = TIEMPO_DELAY;

		enemy->dir=4;							//Busca por la derecha
		enemy-> sprite = SPRITESENEMIGOLEFT;
		enemy->mover=SI;

		//REPINTA
		if(enemy->mover){
			cpct_waitVSYNC();
			redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
			enemy->mover=NO;
		}
		
		enemy->NSEWstate = 0;
		enemy->state = 0;
		if(enemy->antState == 1){
		enemy->antState = 3;
		enemy->state = 2;
		//getShortedDistance(enemy,mapa,prota,cintas);
		}
	}
	
	}
}

}

//Va a comprobar si la cinta está en su sitio o no y activa la alarma si ya no sigue allí

void compruebaCinta(TCinta* cintas[NUM_CINTAS], Tenemy* enemy,u8* mapa,TJugador* prota){
	u8 i=0;
	for(;i< NUM_CINTAS;++i){
		if(cintas[i]->locationMap==enemy->locationMap && cintas[i]->arriba == enemy->arriba && cintas[i]->floor == prota->floor){
			if(goTo(cintas[i]->x + G_OBJETO_W,cintas[i]->y+ G_OBJETO_H,enemy,mapa,prota,cintas)){
				enemy->state = 0;
				if(!cintas[i]->inMap){//Si la cinta ya no está
					//buscaNSEW(prota,enemy,cintas,mapa);
					
					cpct_setBorder(HW_RED);
					enemy->state = 3;

				} 
			}else{
				// no esta la cinta vuelve a patrulla normal
				enemy->state = 2;
			}
		}
	}
}

//Dadas unas coordenadas X e Y, envía al enemigo hasta allí
//Se puede usar para WayPoints mientras se les pasen las coordenadas
u8 goTo(u8 x, u8 y, Tenemy* enemy,u8* mapa,TJugador* prota,TCinta* cintas[NUM_CINTAS]){
	u8 llegado = 0;
	cpct_waitVSYNC();
	//hacer que de forma aleatoria mire NSEW
	if(enemy->locationMap == prota->locationMap){
	if(cpct_rand() > RANDOMNSEW ){
		enemy->state = 3;
		//buscaNSEW(prota,enemy,cintas,mapa);
	}
	/*else if(enemy->auxX == enemy->x && enemy->auxY == enemy->y){
		enemy->state = 1;
		enemy->auxY = enemy->auxX = 0;

	}*/
	else{
		//ejecucion nolmal de goTo
		//enContactoCintaEnemigo(cintas,enemy, enemy->mapa);

		enemy->auxX = enemy->x;
		enemy->auxY = enemy->y;
		if(enemy->x != x){
			if(enemy->x < x){
				moveRightEnemy(enemy);
			}
			else if(enemy->x > x){
				moveLeftEnemy(enemy);
			}
		}
		
		if(enemy->y != y){
			if(enemy->y - y != 1 && enemy->y - y != -1 ){
				if(enemy->y <  y ){
					moveDownEnemy(enemy);
				}
				else if(enemy->y > y ){
					moveUpEnemy(enemy);
				}
			}
		}

		if(enemy-> x == x && (enemy-> y == y || enemy->y - y == 1 || enemy->y - y == -1) ){
			llegado = 1;
			enemy->auxY = enemy->auxX = 0;
		}

		if(enemy->auxX == enemy->x && enemy->auxY == enemy->y){
			enemy->state = 1;
			enemy->auxY = enemy->auxX = 0;
			llegado = 1;
		}

		if(enemy->mover){
			redibujarEnemigo(enemy,mapa,enemy->locationMap,prota->arriba);
			if(loVeo(prota,enemy)){
				if(enemy->dir == 1){
			moveUpEnemy(enemy);
			}
			else if(enemy->dir == 2){
			moveRightEnemy(enemy);
			}
			else if(enemy->dir == 3){
			moveDownEnemy(enemy);
			} 
			else if(enemy->dir == 4){
			moveLeftEnemy(enemy);
			}
			//REPINTA
			if(enemy->mover){
			redibujarEnemigo(enemy,mapa,prota->locationMap,prota->arriba);
			enemy->mover=NO;
			}

				enemy->state = 1;
				//persecucion(prota,enemy,mapa);
			}
			enemy->mover=NO;
		}
	}
}
	return llegado;
}

void patrol(Tenemy* enemy,u8* mapa,TJugador* prota,TCinta* cintas[NUM_CINTAS]){
	u8 posX = enemy->patrolPosition->x;
	u8 posY = enemy->patrolPosition->y;
	if (enemy->locationMap == prota->locationMap){
		if(enemy->arriba == prota->arriba){
		   	if(enemy->floor == prota->floor){
				if (loVeo(prota,enemy)){
					enemy->state = 1;
					//persecucion(prota,enemy,mapa);
				}
		
				else {//Busco dónde se puede haber ido
			
					if (goTo(posX,posY,enemy,mapa,prota,cintas)){
						if(enemy->dirpat){//si está haciendo la patrulla en dirección contraria
							if(enemy->patrolPosition == enemy->patrolPosition->pre){
								enemy->dirpat=0;
								enemy->patrolPosition = enemy->patrolPosition->sig;
							}
							else{
								enemy->patrolPosition = enemy->patrolPosition->pre;
							}
						}
						else{
							if(enemy->patrolPosition == enemy->patrolPosition->sig){
								enemy->dirpat=1;
								enemy->patrolPosition = enemy->patrolPosition->pre;
							}
							else{
								enemy->patrolPosition = enemy->patrolPosition->sig;
							}
						}
					}
				}
		
			}
	  	}
	}
}

void enemyAI(Tenemy* enemy,u8* mapa,TJugador* prota,TCinta* cintas[NUM_CINTAS]){
	switch(enemy->state){
		case 0: patrol(enemy,mapa,prota,cintas);//estdo inicial de patrulla
 			break;
		case 1: persecucion(prota,enemy,mapa);
			break;
		case 2: compruebaCinta(cintas,enemy,mapa,prota);
			break;
		case 3: buscaNSEWConDelay(prota,enemy,mapa);
			break;
		case 4:
			break;
	}
}



//------------------------------------------------------------------------------------------------------------------------------------------//
//Comportamiento cámara																														//
//------------------------------------------------------------------------------------------------------------------------------------------//

//La cámara me devuelve SI si está en mi campo de visión
/*u8 loVeoCam(TJugador* prota, TCamera* cam){

	if(prota->state){// Si el prota es invisible
		return NO;
	}

	//------------------------------------------------------------------------------------------------------------------------------------------------------//
	//		 |¯¯¯¯¯¯¯|																																		//
	//		 |X X X X|																																		//
	//		 |X X X X|																																		//
	//		 |X X X X|		La cámara ve 4 cuadros en el eje X y 9 cuadros en el eje Y, cuatro a su izquierda, cuatro a su derecha y el que tiene en frente	//
	//		C|X X X X|																																		//
	//		 |X X X X|		La cámara no ve a sus lados ni detrás de ella misma a no ser de que cambie de dirección											//
	//		 |X X X X|																																		//
	//		 |X X X X|																																		//
	//		 |_______|																																		//
	//------------------------------------------------------------------------------------------------------------------------------------------------------//
	
	//Si la cámara mira a la derecha
	else if(cam->dir == 2){
		if(prota->x > cam->x + (G_SPRITESCAMARA_W*5)){										//En el caso de que esté fuera de su campo de vision por delante
			return NO;
		}
		else if (prota->x+ G_SPRITESJUGADORES_1_W < cam->x +G_SPRITESCAMARA_W){				//En el caso de que esté fuera de su campo de vision por detrás
			return NO;
		}
		else{	//En el caso de que esté dentro de su campo de visión en el eje X
			if (prota->y+ G_SPRITESJUGADORES_1_H < cam->y - (G_SPRITESCAMARA_H*4)){			//En el caso de que esté fuera de su campo de vision por arriba
				return NO;
			}
			else if(prota->y > cam->y + (G_SPRITESCAMARA_H*5)){								//En el caso de que esté fuera de su campo de vision por abajo
				return NO;
			}
			else{//SÍ está en su campo de visión
				return SI;
			}
		}
	}

	//---------------//
	//	 |¯¯¯¯¯¯¯|	 //
	//	 |X X X X|	 //	
	//	 |X X X X|	 //	
	//	 |X X X X|	 //	
	//	 |X X X X|C  //
	//	 |X X X X|	 //
	//	 |X X X X|	 //	
	//	 |X X X X|	 //		
	//	 |_______|	 //
	//---------------//

	//Si la cámara mira a la izquierda
	else if(cam->dir == 4){
		if(prota->x > cam->x- G_SPRITESCAMARA_W){											//En el caso de que esté fuera de su campo de vision por detrás
			return NO;
		}
		else if(prota->x+ G_SPRITESJUGADORES_1_W < cam->x - (G_SPRITESCAMARA_W*4)){			//En el caso de que esté fuera de su campo de vision por delante
			return NO;
		}
		else{//En el caso de que esté dentro de su campo de visión en el eje X
			if (prota->y+ G_SPRITESJUGADORES_1_H < cam->y - (G_SPRITESCAMARA_H*4)){			//En el caso de que esté fuera de su campo de vision por arriba
				return NO;
			}
			else if(prota->y > cam->y + (G_SPRITESCAMARA_H*5)){								//En el caso de que esté fuera de su campo de vision por abajo
				return NO;
			}
			else{//SÍ está en su campo de visión
				return SI;
			}
		}
	}

	//-----------------------//
	//  ___________________  //
	// | X X X X X X X X X | //
	// | X X X X X X X X X | //
	// | X X X X X X X X X | //
	// |___________________| //
	//      	 E 		     //
	//-----------------------//

	//Si la cámara mira arriba
	else if(cam->dir == 1){
		if(prota->x > cam->x +(G_SPRITESCAMARA_W*5)){										//En caso de que esté fuera de su campo de vision por la derecha
			return NO;
		}
		else if(prota->x+G_SPRITESJUGADORES_1_W < cam->x - (G_SPRITESCAMARA_W*4)){			//En caso de que esté fuera de su campo de visión por la izquierda
			return NO;
		}
		else{
			if(prota->y > cam->y){															//En caso de que esté fuera de su campo de visión por delante
				return NO;
			}
			else if( prota->y + G_SPRITESJUGADORES_1_H < cam->y - (G_SPRITESCAMARA_H*4)){	//En caso de que esté fuera de su campo de visión por detrás
				return NO;
			}
			else{//SÍ está en su campo de visión
				return SI;
			}
		}
	}
	//-----------------------//
	//  _________E_________  //
	// | X X X X X X X X X | //
	// | X X X X X X X X X | //
	// | X X X X X X X X X | //
	// |___________________| //
	//      	  		     //
	//-----------------------//
	
	//Si la cámara mira abajo
	else if(cam->dir == 3){
		if(prota->x > cam->x +(G_SPRITESCAMARA_W*5)){										//En caso de que esté fuera de su campo de vision por la derecha
			return NO;
		}
		else if(prota->x+G_SPRITESJUGADORES_1_W < cam->x - (G_SPRITESCAMARA_W*4)){			//En caso de que esté fuera de su campo de visión por la izquierda
			return NO;
		}
		else{
			if(prota->y > cam->y +(G_SPRITESCAMARA_H*5)){									//En caso de que esté fuera de su campo de visión por delante
				return NO;
			}
			else if(prota->y + G_SPRITESJUGADORES_1_H < cam->y + G_SPRITESCAMARA_H){			//En caso de que esté fuera de su campo de visión por detrás
				return NO;
			}
			else{//SÍ está en su campo de visión
				return SI;
			}
		}
	}
	else{//Nunca entra por aqui, pero el no lo sabe
		return NO;
	}
}

//Se disparará la alarma solo si se ha visto al jugador
void dispararAlarma(Tenemy* enemigos[NUM_ENEMIGOS_NIVEL],TCamera* cam, TJugador* prota,u8* mapa,TCinta* cintas[NUM_CINTAS]){	//Dispara la alarma y hace que el guardia más cercano se acerque a ver que ocurre
	u8 i=0; //iterador bucle
	u16 minDist= 9999;//Se inicializa el valor a un número alto para poder calcular eel mínimo
	u16 manDist=0;
	u8 trabajador =0; //Almacenará el enemigo que tiene que ir a dónde se ha activado la alarma
	Point2D origin, destiny;

	//Comprobamos si la cámara ha activado la alarma

	if(cam->state){
		destiny.x=prota->x;
		destiny.y=prota->y;

		for(;i<NUM_ENEMIGOS_NIVEL;++i){
			if(enemigos[i]->locationMap == prota->locationMap){//Si estamos en el mapa actual
				origin.x= enemigos[i]->x;
				origin.y= enemigos[i]->y;

				//Calcular distancia
				manDist= manhattanDistance(&origin,&destiny);
				if(minDist > manDist){
					minDist= manDist;
					trabajador=i;
				}
			}
		}

		goTo(prota->x,prota->y,enemigos[trabajador],mapa,prota,cintas); //Lleva al trabajador hasta donde fue visto el prota por última vez

		buscaNSEW(prota,enemigos[trabajador],cintas,mapa); //Busca al enemigo en las 4 direcciones
	}
}*/