;;-----------------------------LICENSE NOTICE------------------------------------
;;
;; This file is part of Firewall Wars.
;;
;;    FirewallWars is free software: you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation, either version 3 of the License.
;; 
;;     FirewallWars is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
;; 
;;     You should have received a copy of the GNU General Public License
;;     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
;; 
;;------------------------------------------------------------------------------

;; Symbols with the names of the CPCtelera functions we want to use
;; must be declared globl to be recognized by the compiler. Later on,
;; linker will do its job and make the calls go to function code.
.globl cpct_drawCharM1_asm
.globl cpct_waitVSYNC_asm
.globl cpct_scanKeyboard_asm
.globl cpct_isAnyKeyPressed_asm
.globl _waitHalts

;;
;; Funcion imprimeString. Este es el punto de entrada de la aplicacion.
;; Se requiere el simbolo global _imprimeString:: para compilar y enlazar correctamente
;;
_imprimeString::
	;; Vamos a dibujar un String, y tenemos que empujar parámetros
	;; al stack primero (ya que la funcion los recupera de allí).
	;; void* video_memory, u8 fg_pen, u8 bg_pen, u8* string
	;; DE video_memory
	;; C fg_pen
	;; B bg_pen
	;; A caracter

	pop hl ;; Obtienes el puntero a la pila y lo guardas en hl   
	exx  

loop:
	pop de ;; DE = Puntero a la localización de la memoria de video donde será dibujado el string
	pop bc ;; B = Color de Fondo, C = Color de la letra
	pop hl ;; Puntero del string
	;;Intercambio los registros y copio los datos para no perderlos
	ld a, (hl)
	or a
	ret z
	;;incremento el puntero a memoria en 4
	inc de
	inc de
	inc hl
	push hl ;; Itero sobre el array de caracteres para imprimir un caracter cada vez
	dec hl

	push bc
	push de
	call cpct_drawCharM1_asm ;; Llamada a la función que pinta el string que se carga mis datos
	call _waitHalts
	call cpct_waitVSYNC_asm

	call cpct_scanKeyboard_asm    ;; Escaneo el teclado
	call cpct_isAnyKeyPressed_asm ;;
	or a
	jr z, loop		 ;; Si el flag Z=0 entonces volvera loop, porque no hay teclas pulsadas

	exx
	push hl
	ret