//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------

//includes
#include <cpctelera.h>
//includes propios
#include "try2.h"
#include "base.h"
#include "dead.h"
#include "paint.h"
#include "player.h"
#include "ia.h"
#include "bateria.h"

#define BATTERY_X 39
#define BATTERY_Y 16


//definicion de puntos de patrulla iniciales
extern WayPoint a1,a11,b1,b11,c1,c11,d1,d11;


extern Time time;
u8* memTimeN;
u8* memEnergy;

//definicion de variables de personajes
TJugador prota;
Tenemy ene1,ene11,ene2,ene21,ene3,ene31,ene4,ene41,ene5,ene51,ene6,ene61;
Tenemy* enemigos[NUM_ENEMIGOS_NIVEL];
TCinta cinta1,cinta2,cinta3,cinta4,cinta5,cinta6,cinta7,cinta8;
TCinta cola1,cola2,cola3,cola4,cola5,cola6,cola7,cola8;
TCinta* cintas[NUM_CINTAS];
TCinta* colas[NUM_CINTAS];
TTeclas teclas;
//inicializacion de metodos
void game(u32 seed);
u32 menu();
void init();
void initTeclas();
void endGame();
void inicializar();
void inicializarProta();
void inicializarObjeto(TCinta*,u8 x,u8 y,u8 map,u8,u8,u8*,u8);
void escribirCaracter(u8*,u8);
void imprimirTiempo(u8*)__z88dk_fastcall ;
void imprimirEnergy(u8*)__z88dk_fastcall;
void borrarEnergy();
void clockSignal();//manda una seññal de clock para poder calcular el gasto de energia 
void inicializarRandomEnemyPositions(Tenemy* ene,u8* mapa,u8 nmap ,u8 arriba,WayPoint* point,u8 path,u8 pos,u8 floor);
void waitHalts();
void printString(const u8*)__z88dk_fastcall;
void switchPrinter(u8)__z88dk_fastcall;
void subirPlanta();
cpct_keyID getKey();

//varieble para sincronizar la musica
u8 syncHander1;
extern void play();

void initHandler(){
	if(++syncHander1 == 6){
		play();
		syncHander1 = 0;
		clockSignal();
		if(++time.cicles == 50){
			time.cicles = 0;
			imprimirTiempo(memTimeN);
			if(++time.seconds == 60){
				time.seconds = 0;
				++time.minutes;
			}
		}
	}
}


//puntero a mapa
u8* mapa;

//Modulo principal
void main(void){
	init();
	while(1){ 
	  game(menu());
	}
}

void initTeclas(){
	//inicializacion de teclas DEFAULT
	teclas.up = Key_W;
	teclas.left = Key_A;
	teclas.down = Key_S;
	teclas.right = Key_D;
	teclas.restart = Key_R;
	teclas.invi = Key_C;
}

//inicializa temas de firmware y demás
void init(){
	cpct_disableFirmware();
	cpct_setVideoMode(0);
	cpct_setBorder(HW_BLACK);
	cpct_setPalette(g_palette,16);
	initTeclas();
}

void game(u32 seed){
	u8 i=0;
	//variable que controla la finalizacion del juego
	u8 finJuego = 1; 

	switchPrinter(0);//Imprime la historia

	cpct_setInterruptHandler(initHandler);
	cpct_clearScreen(0);
	//se comprueba que la seed no es 0
	if(!seed){
		++seed;
	}
	cpct_srand(seed);
	inicializar();
	//prota.floor++;
	//subirPlanta();
	
	while (finJuego  && !cpct_isKeyPressed(teclas.restart) && !enContactoEnemigo(&prota,enemigos,mapa)){//Mientras no maten
		comprobarTeclado(&prota,&mapa,cintas,colas,enemigos);
		cpct_waitVSYNC();
		if(prota.cintas == NUM_CINTAS){
			//estan todas las cintas hay que meter un EnContacto con CPC para que chequee si ha llegado al CPC
			if(enContactoCPC(&prota)){
				//llega a la pantalla del cpc y toca el CPC y se acaba el juego
				finJuego = 0;
			}
		}else{
			if(enContactoEscalera(&prota)){
			++prota.floor; 
			subirPlanta();
		}
		}

		
		if(prota.energy != 0){
			imprimirEnergy(memEnergy);
		}
		
		if (prota.locationMap == 2){
			cpct_waitVSYNC();
			cpct_waitVSYNC();
			cpct_waitVSYNC();
			cpct_waitVSYNC();
			cpct_waitVSYNC();
			cpct_waitVSYNC();
		}
		//controlEnergia(&prota,&time);
		if(prota.mover)	{
			redibujarProta(&prota,mapa,cintas);
			redibujarProta(&prota,mapa,colas);
			prota.mover = NO;
		}
		//Lo siguiente mueve a todos los enemigos en sus respectivos mapas
		i=0;
		for(;i<NUM_ENEMIGOS_NIVEL;++i){
			//cpct_waitVSYNC();
			//moveRandom(enemigos[i],prota.locationMap);//Si estas en el mapa se mueve random
			//patrol(enemigos[i],mapa,&prota,cintas);
			enemyAI(enemigos[i],mapa,&prota,cintas);
			//compruebaCinta(cintas,enemigos[i],mapa,&prota);
			//persecucion(&prota,enemigos[i],cintas,mapa);
			
			if(enemigos[i]->mover){
				redibujarEnemigo(enemigos[i],mapa,prota.locationMap,prota.arriba);
				enemigos[i]->mover=NO;
			}
		}
		cpct_scanKeyboard_f();
	}
	cpct_setInterruptHandler(endHandler);
	//comprueba si se ha terminado la partida por muerte o por fin de juego
	if(finJuego == 0){
		//se termina el juego
		imprimeAMSTRAD();
		endGame();
	}
	else{
		//matan al prota
		u8* memptr ;
		cpct_setBorder(HW_BLACK);
		cpct_clearScreen(0);
		memptr= cpct_getScreenPtr(CPCT_VMEM_START,10,90);  
		cpct_drawStringM0("WE'RE DOOMED!!!",memptr,15,0);//Dibujar string en modo 0
		do{
			cpct_scanKeyboard_f();
		}while(! (cpct_isAnyKeyPressed()));
	}
		cpct_setInterruptHandler(endHandler);
}

u32 menu(){
	u32 seed = 0;
	cpct_setBorder(HW_BLACK);
	cpct_clearScreen(0);//Borramos la pantalla
	cpct_akp_musicInit(try2_mysong);
	cpct_drawSolidBox(cpct_getScreenPtr(CPCT_VMEM_START,0,76),cpct_px2byteM0(15,15),64,124);
	cpct_drawSolidBox(cpct_getScreenPtr(CPCT_VMEM_START,15,76),cpct_px2byteM0(15,15),64,124);
	imprimeMenu();
	//Esperar hasta pulsar INTRO
	do{
		++seed;
		cpct_scanKeyboard_f();
		if(cpct_isKeyPressed(Key_1)){
			switchPrinter(1);
		}
		else if(cpct_isKeyPressed(Key_2)){
			switchPrinter(2);
		}
		else if(cpct_isKeyPressed(Key_3)){
			switchPrinter(3);
		}
	}while(! (cpct_isKeyPressed(Key_Enter) || cpct_isKeyPressed(Key_Return)));
	return seed;
}

void endGame(){
	u8* memptr ;
	u8* memTiemptr;
	cpct_setBorder(HW_BLACK);
	cpct_clearScreen(0);
	memptr= cpct_getScreenPtr(CPCT_VMEM_START,0,90);  
	memTiemptr= cpct_getScreenPtr(CPCT_VMEM_START,30,110);  
	cpct_drawStringM0("YOU SAVED THE WORLD!",memptr,15,0);//Dibujar string en modo 0
	imprimirTiempo(memTiemptr);
	//Esperar hasta pulsar una tecla
	do{
		cpct_scanKeyboard_f();
	}while(! (cpct_isAnyKeyPressed()));
	switchPrinter(3);
}

void inicializar(){
	//punteros a la posicion de differentes objetos del banner
	u8* memTime = cpct_getScreenPtr(CPCT_VMEM_START,10,5);
	u8* memBattery = cpct_getScreenPtr(CPCT_VMEM_START,BATTERY_X,BATTERY_Y);
	memEnergy = cpct_getScreenPtr(CPCT_VMEM_START,40,20);
	memTimeN = cpct_getScreenPtr(CPCT_VMEM_START,10,20);

	cpct_etm_setTileset2x4(g_tileset);
	mapa = g_map1;
	//inicializar tiempo
	time.cicles = 0;
	time.seconds = 0;
	time.minutes = 0;
	//dibujamos la bateria
	cpct_drawSprite(g_bateria,memBattery,G_BATERIA_W,G_BATERIA_H);
	//escribimos TIME
	cpct_drawStringM0("TIME ",memTime,15,0);
	//imprimimos El tiempo
	imprimirTiempo(memTimeN);
	//ponemos el borde a negro
	cpct_setBorder(HW_BLACK);
	
	//dibujamos el mapa
	dibujarMapa(mapa);
	//inicializamos al prota
	inicializarProta();
	//dibujamos al prota
	dibujarProta(&prota);
	//dibujamos el cpc

	//inicializamos a los enemigos
	//mapa 1
	inicializarRandomEnemyPositions(&ene1,mapa,0 ,0,&a1,0,0,0);
	inicializarRandomEnemyPositions(&ene11,mapa,0 ,0,&a11,0,1,0);
	//mapa 2
	inicializarRandomEnemyPositions(&ene2,g_map2,1,0,&b1,1,2,0);
	inicializarRandomEnemyPositions(&ene21,g_map2,1,0,&b11,1,3,0);
	//mapa 11
	inicializarRandomEnemyPositions(&ene3,g_map11,1,1,&c1,1,4,0);
	inicializarRandomEnemyPositions(&ene31,g_map11,1,1,&c11,1,5,0);
	//mapa 12
	inicializarRandomEnemyPositions(&ene4,g_map12,0,1,&d1,1,6,0);
	inicializarRandomEnemyPositions(&ene41,g_map12,0,1,&d11,1,7,0);

	//mapa 1
	/*inicializarRandomEnemyPositions(&ene5,mapa,0 ,0,&a1,0,8,1);
	inicializarRandomEnemyPositions(&ene51,mapa,0 ,0,&a11,0,9,1);
	//mapa 2
	inicializarRandomEnemyPositions(&ene6,g_map2,1,0,&b1,1,10,1);
	inicializarRandomEnemyPositions(&ene61,g_map2,1,0,&b11,1,11,1);
	//mapa 11
	inicializarRandomEnemyPositions(&ene6,g_map11,1,1,&c1,1,12,1);
	inicializarRandomEnemyPositions(&ene61,g_map11,1,1,&c11,1,13,1);
	//mapa 12
	inicializarRandomEnemyPositions(&ene6,g_map12,0,1,&d1,1,14,1);
	inicializarRandomEnemyPositions(&ene61,g_map12,0,1,&d11,1,15,1);*/


    dibujarTodosEnemigos(enemigos,prota.locationMap,0,0);
	
	inicializarObjeto(&cinta1,70,55,0,0,0,g_objeto_0,0);
	inicializarObjeto(&cinta2,50,55,1,0,0,g_objeto_1,0);
	inicializarObjeto(&cinta3,5,178,1,1,0,g_objeto_2,0);
	inicializarObjeto(&cinta4,15,178,0,1,0,g_objeto_3,0);
	inicializarObjeto(&cinta5,75,55,0,0,1,g_objeto_4,0);
	inicializarObjeto(&cinta6,50,55,1,0,1,g_objeto_5,0);
	inicializarObjeto(&cinta7,5,178,1,1,1,g_objeto_6,0); // <- watt????????????
	inicializarObjeto(&cinta8,15,50,0,1,1,g_objeto_7,0);
	cintas[0] = &cinta1;
	cintas[1] = &cinta2;
	cintas[2] = &cinta3;
	cintas[3] = &cinta4;
	cintas[4] = &cinta5;
	cintas[5] = &cinta6;
	cintas[6] = &cinta7;
	cintas[7] = &cinta8;

	dibujarTodosObjetos(cintas,prota.locationMap,0,0);

	inicializarObjeto(&cola1,5,55,0,0,0,g_cola,1);
	inicializarObjeto(&cola2,50,75,1,0,0,g_cola,1);
	inicializarObjeto(&cola3,15,180,1,1,0,g_cola,1);
	inicializarObjeto(&cola4,30,55,0,1,0,g_cola,1);
	inicializarObjeto(&cola5,5,50,0,0,1,g_cola,1);
	inicializarObjeto(&cola6,5,55,1,0,1,g_cola,1);
	inicializarObjeto(&cola7,15,125,1,1,1,g_cola,1);
	inicializarObjeto(&cola8,12,178,0,1,1,g_cola,1);
	colas[0] = &cola1;
	colas[1] = &cola2;
	colas[2] = &cola3;
	colas[3] = &cola4;
	colas[4] = &cola5;
	colas[5] = &cola6;
	colas[6] = &cola7;
	colas[7] = &cola8;

	dibujarTodosObjetos(colas,prota.locationMap,0,0);
}
void subirPlanta(){
	u8 i = 0;
	prota.locationMap = 0;
	prota.arriba = 0;
	prota.x = prota.px = 10;
	prota.y = prota.py	= 180;
	mapa = g_map1;
	//
	for(;i<NUM_ENEMIGOS_NIVEL;++i){
		inicializarRandomEnemyPositions(enemigos[i],enemigos[i]->mapa,enemigos[i]->locationMap ,enemigos[i]->arriba,enemigos[i]->patrolPosition,enemigos[i]->dirpat,i,1);
	}
	dibujarMapa(g_map1);
	dibujarProta(&prota);
	dibujarTodosObjetos(cintas,prota.locationMap,0,prota.floor);
	dibujarTodosObjetos(colas,prota.locationMap,0,prota.floor);
	dibujarTodosEnemigos(enemigos,prota.locationMap,0,prota.floor);

}
void inicializarProta(){
	prota.x = prota.px = 10;
	prota.y = prota.py	= 180;
	prota.mover = NO;
	prota.sprite = g_spritesJugadores_1;
	prota.vida = 100;
	prota.cintas = 0;
	prota.state = 0;
	prota.locationMap = 0;
	prota.energy = 5;
	prota.arriba = 0;
	prota.cicles = 0; 
	prota.floor = 0;
}

void inicializarObjeto(TCinta* ci,u8 x,u8 y,u8 map,u8 arriba,u8 piso,u8* sprite,u8 cola) {
	ci->x = x;
	ci->y = y;
	ci->inMap = 1; //Está en mapa
	ci->locationMap = map;
	ci->arriba = arriba;
	ci->sprite = sprite;
	ci->floor = piso;
	ci->cola =cola;
}

void escribirCaracter(u8* memDir,u8 character){
	cpct_drawCharM0 (memDir,15,0, character);	
}

void imprimirTiempo(u8* memDir) __z88dk_fastcall {
	escribirCaracter(memDir,(time.minutes/10) + 48);
	escribirCaracter(memDir+4,(time.minutes%10) + 48);
	escribirCaracter(memDir+8,58);
	escribirCaracter(memDir+12,(time.seconds/10) + 48);
	escribirCaracter(memDir+16,(time.seconds%10) + 48);
}

void imprimirEnergy(u8* memDir)__z88dk_fastcall{
	cpct_drawSolidBox(memDir,20,prota.energy,10);
}

void borrarEnergy(){
	cpct_waitVSYNC();
	cpct_drawSolidBox(memEnergy,0,5,10);
}

void clockSignal(){
	if(prota.state){
		if(++prota.cicles == 180){
			prota.cicles = 0;
			borrarEnergy();
			if(--prota.energy <= 0){
				invisible(&prota);
			}
		}
	}
}

void inicializarRandomEnemyPositions(Tenemy* ene,u8* mapa,u8 nmap ,u8 arriba,WayPoint* point,u8 path,u8 pos,u8 floor){
	u8 number = cpct_rand()%20;
	while(--number){
		point = point->sig;
	}
	inicializarEnemigo(ene ,point->x,point->y,100,mapa,nmap,arriba,point,path,floor);
	enemigos[pos] = ene;
}

//Espera el número de halts indicado en su variable interna
void waitHalts(){
	u8 wait = 7;
	while(--wait){
		__asm__("halt");
	}
}

//Imprime, dependiendo del número que se le pase, la historia, los créditos, o los controles estándard del juego
void switchPrinter(u8 eleccion)__z88dk_fastcall{
	u8* memptr;
	switch (eleccion){
		case 0: //Imprime la historia
			cpct_akp_musicInit(base_mysong);
			cpct_setInterruptHandler(initHandler25);
			printString("     2017, after Trump\'s rise to power and his longing to destroy everything   that represents international culture,  the world is being threatened by a      series of nuclear warheads.                   You, and advanced soldier from thedigital era, have been transformed into data to recover the deactivation code ofthe mentioned nuclear warheads which    will be launched in 10 minutes.               Your mission is to infiltrate intothe enemy database, evading the         components of the firewall to recover   the eight parts that form the           deactivation code.                            Be careful, if you touch any      firewall component your data will be    deleted from the system and you will    never be able to return to the real     world.                                        To complete your task, you must   take the 8 parts of the code to the     output bus, linked to the sprite of a   CPC464 which only unlocks with a specialcode that you must discover by yourself.\0");
			waitXHalts(600);
			cpct_clearScreen(0);//Borramos la pantalla
			printString("     In order to help you with your    mission, we have infiltrated some       special codes into de database which    will let you, for a short time, become  invisible in front of the firewall\'s    components.                                   These codes will be deleted once  used and you will not be able to use    them again, so use them wisely.               We wish you good luck, soldier,   and make good profit of your powers.\0");
			cpct_setInterruptHandler(endHandler);
			waitXHalts(600);
			cpct_akp_musicInit(try2_mysong);
			cpct_setVideoMode(0);
			break;
		case 1: //Imprime los controles standard
			//imprimimos un cuadrado negro para limpiar el menú
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
						
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,100);
			cpct_drawStringM0("W Up",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,110);
			cpct_drawStringM0("A Left",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,120);
			cpct_drawStringM0("S Down",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,130);
			cpct_drawStringM0("D Right",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,140);
			cpct_drawStringM0("C Invisibility",memptr,15,0);			
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,14,150);
			cpct_drawStringM0("R Restart",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,2,170);
			cpct_drawStringM0("PRESS 'R' TO RETURN",memptr,15,0);

			do{
			    cpct_scanKeyboard_f();
			}while(! (cpct_isKeyPressed(Key_R)));//Espera a que pulses R para volver atrás

			imprimeMenu();
			break;
		case 2: //Imprime submenú para cambiar las teclas
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,100);
			cpct_drawStringM0("1. Set Default",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("2. Set New Keys",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,2,170);
			cpct_drawStringM0("PRESS 'R' TO RETURN",memptr,15,0);
			do{
			    cpct_scanKeyboard_f();
			    if(cpct_isKeyPressed(Key_1)){
			    	initTeclas();
			    	break;
				}
				else if(cpct_isKeyPressed(Key_2)){
					switchPrinter(4);
					break;
				}
			}while(! (cpct_isKeyPressed(Key_R)));//Espera a que pulses R para volver atrás
			imprimeMenu();
			break;
		case 3: //Imprime los creditos
			cpct_setInterruptHandler(endHandler);
			cpct_akp_musicInit(base_mysong);
			cpct_setInterruptHandler(initHandler25);
			printString("           FIREWALL WARS                                                                -A Navy Xicken Game-                                                         SPRITES BY - Reyeselda95                  MUSIC BY - Reyeselda95               TILEMAPS BY - jaquer                 PROGRAMMING BY - jaquer y Reyeselda95                                                    -SPECIAL THANKS-                                                              LRONALDO & CPCTELERA                 CPCTELERA REFERENCE MANUAL              ZILOG Z80 REFERENCE MANUAL                   AMSTRAD CPC 464                      THE LEGEND OF CPCERDO                                                                -DEVELOPERS-                                                       ALEJANDRO REYES ALBILLAR  (Reyeselda95)   IVAN RODRIGUEZ FERRANDEZ   (jaquer)                                                   THANKS FOR PLAYING :D");//String con los creditos
			waitXHalts(600);
			cpct_setInterruptHandler(endHandler);
			cpct_clearScreen (0);
			cpct_setVideoMode(0);
			cpct_drawSolidBox(cpct_getScreenPtr(CPCT_VMEM_START,0,76),cpct_px2byteM0(15,15),64,124);
			cpct_drawSolidBox(cpct_getScreenPtr(CPCT_VMEM_START,15,76),cpct_px2byteM0(15,15),64,124);
			cpct_akp_musicInit(try2_mysong);
			cpct_scanKeyboard();
			imprimeMenu();
			break;
		case 4: //Imprime los mensajes de guia y cambia las teclas
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("PRESS THE KEY",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,30,140);
			cpct_drawStringM0("UP",memptr,15,0);
			teclas.up=getKey();
			cpct_scanKeyboard();//Para inicializar el array de mapeo a 1
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,25,140);
			cpct_drawStringM0("DOWN",memptr,15,0);
			while(getKey()==teclas.up){
				memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
				dibujarRotulo(memptr);
				memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
				cpct_drawStringM0("TRY ANOTHER ONE",memptr,15,0);
			}
		    teclas.down=getKey();
		    cpct_scanKeyboard();//Para inicializar el array de mapeo a 1
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("PRESS THE KEY",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,25,140);
			cpct_drawStringM0("LEFT",memptr,15,0);
			while(getKey()==teclas.down || getKey()==teclas.up){
				memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
				dibujarRotulo(memptr);
				memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
				cpct_drawStringM0("TRY ANOTHER ONE",memptr,15,0);
			}
		    teclas.left=getKey();
		    cpct_scanKeyboard();//Para inicializar el array de mapeo a 1
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("PRESS THE KEY",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,25,140);
			cpct_drawStringM0("RIGHT",memptr,15,0);
			while(getKey()==teclas.down || getKey()==teclas.up || getKey()==teclas.left){
				memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
				dibujarRotulo(memptr);
				memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
				cpct_drawStringM0("TRY ANOTHER ONE",memptr,15,0);
			}
		    teclas.right=getKey();
		    cpct_scanKeyboard();//Para inicializar el array de mapeo a 1
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);		    
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("PRESS THE KEY",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,22,140);
			cpct_drawStringM0("RESTART",memptr,15,0);
			while(getKey()==teclas.down || getKey()==teclas.up || getKey()==teclas.right || getKey()==teclas.left){
				memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
				dibujarRotulo(memptr);
				memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
				cpct_drawStringM0("TRY ANOTHER ONE",memptr,15,0);
			}   
		    teclas.restart=getKey();
		    cpct_scanKeyboard();//Para inicializar el array de mapeo a 1
			memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
			dibujarRotulo(memptr);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
			cpct_drawStringM0("PRESS THE KEY",memptr,15,0);
			memptr=cpct_getScreenPtr(CPCT_VMEM_START,12,140);
			cpct_drawStringM0("INVISIBILITY",memptr,15,0);
			while(getKey()==teclas.down || getKey()==teclas.up || getKey()==teclas.right || getKey()==teclas.left || getKey()==teclas.restart){
				memptr= cpct_getScreenPtr(CPCT_VMEM_START,20,10);
				dibujarRotulo(memptr);
				memptr=cpct_getScreenPtr(CPCT_VMEM_START,10,120);
				cpct_drawStringM0("TRY ANOTHER ONE",memptr,15,0);
			}
		    teclas.invi=getKey();
			break;
		default: break;
	}
}

void printString(const u8* text1)__z88dk_fastcall{
	waitHalts();
	cpct_clearScreen (0);
	cpct_setVideoMode(1);
	imprimeString(CPCT_VMEM_START,2,0,text1);//Con el 2 o 3 se ve bastante bien
}

cpct_keyID getKey() {
  // Traverse the keystatus vector from end to start, to help
  // the compiler better optimize this code
  u8 i = 10, *keys = cpct_keyboardStatusBuffer + 9;
  u16 keypressed;
  
  // Wait for a keypress
  do { cpct_scanKeyboard(); } while ( ! cpct_isAnyKeyPressed() );

  // Analyse which key has been pressed and return its keycode
  do {
    // We analyse groups of keys byte by byte (8 by 8, 1 bit per key)
    // If no single key is pressed in this group, all bits will be on, and the byte will be 0xFF
    // Then, XORing the byte with 0xFF will result in 0 unless some key from this group is pressed
    keypressed = *keys ^ 0xFF;
    if (keypressed) 
       return (keypressed << 8) + (i - 1); // Convert to cpct_keyID format: 8 first bits = key mask, 8 next bits, keyboard row (0-9)
    --keys;
  } while(--i);

  // No key was pressed 
  return 0;
}