//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------
//Este fichero se encarga de dibujar, borrar y redibujar los elementos del juego
#ifndef _PAINT_H_
#define _PAINT_H_

#include "player.h"

//includes con los objetos a pintar
#include <cpctelera.h>
#include "tiles.h"
#include "map1.h"
#include "map2.h"
#include "map3.h"
#include "map1-1.h"
#include "map1-2.h"
#include "map3-1.h"
#include "enemy.h"
#include "objeto.h"
#include "cola.h"
#include "spritesJugadores.h"
#include "CPC.h"
#include "escaleras.h"
#include "menu.h"
#include "dead.h"

//#include "barraSuperior.h"

#define ORIGEN_MAPA_Y 40
#define ORIGEN_MAPA cpctm_screenPtr(CPCT_VMEM_START, 0,ORIGEN_MAPA_Y)

extern void imprimeString(u8* video_memory, u8 bg_pen, u8 fg_pen, u8* string);
extern void imprimeStringSin(u8* video_memory, u8 bg_pen, u8 fg_pen, u8* string);
extern void play();

void dibujarMapa(u8*)  __z88dk_fastcall ;
void dibujarProta(TJugador*)  __z88dk_fastcall ;
void borrarProta(TJugador*,u8*);
void redibujarProta(TJugador*,u8*,TCinta*[NUM_CINTAS]);
void dibujarEnemigo(Tenemy*) __z88dk_fastcall ;
void dibujarObjeto(TCinta*) __z88dk_fastcall ;
void dibujarCPC();
void dibujarEscaleras();
void borrarObjeto(TCinta*,u8*);
void dibujarTodosObjetos(TCinta* [NUM_CINTAS], u8,u8,u8);
void dibujarTodosEnemigos(Tenemy* [NUM_ENEMIGOS_NIVEL], u8,u8,u8);
void borrarEnemigo(Tenemy*,u8*);
void redibujarEnemigo(Tenemy*,u8*,u8,u8);
void invisible(TJugador*) __z88dk_fastcall ;
void animacionPerdido(TJugador*,Tenemy*,u8*);
void waitXHalts(u16) __z88dk_fastcall;
void dibujarRotulo(u8*)__z88dk_fastcall;
void imprimeMenu();
void imprimeAMSTRAD();
void printString2(const u8* text1,u8*);
void initHandler25();
void endHandler(); //Para terminar la musica

#endif