//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------
#include "player.h"
#include "paint.h"

//Incluimos los sprites que necesita para acceder a las medidas de los mismos
#include "spritesJugadores.h"

u8* const g_mundo[NUM_MAPAS] = {g_map1,g_map2,g_map31};
u8* const g_mundoA[NUM_MAPAS] = {g_map12,g_map11,g_map31};
extern u8 syncHander;
extern TTeclas teclas;

//cambios mapa
//Cambia el mapa a la habitación siguiente
void avanzarMapa(TJugador* prota,u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	u8 state = 0;
	//u8* mapChange = g_map3; 
	cpct_setBorder(HW_BLACK);
	if (prota->locationMap < NUM_MAPAS - 1){
		++prota->locationMap;
		if(prota->locationMap == 2 && prota->floor == NUMPLANTAS && prota->cintas == NUM_CINTAS){
			u8* newMapa = g_map3;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+16)*40+9]=0;
				newMapa[(inc+16)*40+10]=0;
			}
			*mapa = newMapa;
			state = 1;
		}else if(prota->locationMap == 2 && prota->floor == NUMPLANTAS){
			u8* newMapa = g_map3;
			u8 inc = 6;
			//*mapa = g_map3;
			while(--inc){
				newMapa[(inc+16)*40+9]=1;
				newMapa[(inc+16)*40+10]=2;
			}
			*mapa = newMapa;
			state = 1;
		}
		else if(prota->locationMap == 2 && prota->cintas != 4){
			u8* newMapa = g_map31;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+14)*40+11]=1;
				newMapa[(inc+14)*40+12]=2;
			}
			*mapa = newMapa;
			state = 2;
		}
		else if(prota->locationMap == 2 && prota->cintas == 4 ){
			u8* newMapa = g_map31;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+14)*40+11]=0;
				newMapa[(inc+14)*40+12]=0;
			}
			*mapa = newMapa;
			state = 2;
		}
		else{
			*mapa = g_mundo[prota->locationMap];
			//state = 2;

		}
		//*mapa = g_mundo[prota->locationMap];
		prota->x = prota->px = 0;
		prota->arriba = 0;
		prota->mover = SI;
		dibujarMapa(*mapa);
		if (state == 1){
			dibujarCPC();
		}
		else if(state == 2){
			dibujarEscaleras();
		}
		
		dibujarTodosObjetos(cintas,prota->locationMap,0,prota->floor);
		dibujarTodosObjetos(colas,prota->locationMap,0,prota->floor);		
		dibujarTodosEnemigos(enemigos,prota->locationMap,0,prota->floor);
	}
}

//Cambia el mapa a la habitación anterior
void retrocerMapa(TJugador* prota, u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	if (prota->locationMap > 0){
		//cpct_setBorder(HW_BLACK);
		prota->locationMap--;
		*mapa = g_mundo[prota->locationMap];
		prota->x = prota->px = ANCHO_PANTALLA - G_SPRITESJUGADORES_1_W;
		prota->arriba = 0;
		prota->mover = SI;
		dibujarMapa(*mapa);
		dibujarTodosObjetos(cintas,prota->locationMap,0,prota->floor);
		dibujarTodosObjetos(colas,prota->locationMap,0,prota->floor);
		dibujarTodosEnemigos(enemigos,prota->locationMap,0,prota->floor);
	}
}

void avanzarMapaArriba(TJugador* prota,u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	u8 state = 0;
	cpct_setBorder(HW_BLACK);
	if (prota->locationMap < NUM_MAPAS - 1){
		++prota->locationMap;
		if(prota->locationMap == 2 && prota->floor == NUMPLANTAS && prota->cintas == NUM_CINTAS){
			u8* newMapa = g_map3;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+16)*40+9]=0;
				newMapa[(inc+16)*40+10]=0;
			}
			*mapa = newMapa;
			state = 1;
		}else if(prota->locationMap == 2 && prota->floor == NUMPLANTAS){
			u8* newMapa = g_map3;
			u8 inc = 6;
			//*mapa = g_map3;
			while(--inc){
				newMapa[(inc+16)*40+9]=1;
				newMapa[(inc+16)*40+10]=2;
			}
			*mapa = newMapa;
			state = 1;
			
		}else if(prota->locationMap == 2 && prota->cintas != 4){
			u8* newMapa = g_map31;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+14)*40+11]=1;
				newMapa[(inc+14)*40+12]=2;
			}
			*mapa = newMapa;
			state = 2;
		}else if(prota->locationMap == 2 && prota->cintas == 4 ){
			u8* newMapa = g_map31;
			u8 inc = 6;
			while(--inc){
				newMapa[(inc+14)*40+11]=0;
				newMapa[(inc+14)*40+12]=0;
			}
			*mapa = newMapa;
			state = 2;
		}
		else{
			*mapa = g_mundoA[prota->locationMap];
			//state = 2;
		}
		//*mapa = g_mundoA[prota->locationMap];
		prota->x = prota->px = 0;
		prota->arriba = 1;
		prota->mover = SI;
		dibujarMapa(*mapa);
		if (state == 1){
			dibujarCPC();
		}
		else if(state == 2){
			dibujarEscaleras();
		}
		dibujarTodosObjetos(cintas,prota->locationMap,1,prota->floor);
		dibujarTodosObjetos(colas,prota->locationMap,1,prota->floor);
		dibujarTodosEnemigos(enemigos,prota->locationMap,1,prota->floor);

	}
}

//Cambia el mapa a la habitación anterior
void retrocerMapaArriba(TJugador* prota, u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	if (prota->locationMap > 0){
		cpct_setBorder(HW_BLACK);
		prota->locationMap--;
		*mapa = g_mundoA[prota->locationMap];
		prota->x = prota->px = ANCHO_PANTALLA - G_SPRITESJUGADORES_1_W;
		prota->arriba = 1;
		prota->mover = SI;
		dibujarMapa(*mapa);
		dibujarTodosObjetos(cintas,prota->locationMap,1,prota->floor);
		dibujarTodosObjetos(colas,prota->locationMap,1,prota->floor);
		dibujarTodosEnemigos(enemigos,prota->locationMap,1,prota->floor);
	}
}

//movimentos Prota
void moveLeft(TJugador* prota,u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	if (prota->x > 0 && comprobarMovimentoLeft(prota,*mapa)){
		prota->x--;
		prota->mover = SI;
	}else if(prota->x == 0 ){
		if(prota->y > 80){
			retrocerMapa(prota,mapa,cintas,colas,enemigos);
		}else{
			retrocerMapaArriba(prota,mapa,cintas,colas,enemigos);
		}
		
	}else{

	}
}

void moveRight(TJugador* prota,u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS],Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]){
	if( prota->x < LIMITE_DERECHO){
		if (comprobarMovimentoRight(prota,*mapa)){
			prota->x++;
			prota->mover = SI;
		}
	} else{
		if(prota->y > 80){
			avanzarMapa(prota,mapa,cintas,colas,enemigos);

		}else{
			avanzarMapaArriba(prota,mapa,cintas,colas,enemigos);
		}
       
	}
}

void moveUp(TJugador* prota,u8* mapa){
	if(prota->y > 1 && comprobarMovimentoUp(prota,mapa)){
		prota->y--;
        prota->y--;
		//prota->y--;
		//prota->y--;
		prota->mover = SI;
	}else{

	}
}

void moveDown(TJugador* prota,u8* mapa){
    if(prota->y < LIMITE_INFERIOR && comprobarMovimentoDown(prota,mapa)){
		prota->y++;
		prota->y++;
	    //prota->y++;
		//prota->y++;
		prota->mover = SI;
	}else{

	}
}

//Mira si estas en contacto con una cinta aumenta el numero de cintas y la borra de la pantalla
void enContactoCinta(TCinta* cintas[NUM_CINTAS],TJugador* prota, u8* mapa){
	u8 i=0;
	u8 x=SI, y =SI;//Los ejes X e Y se inicializan a ocupado
	u8 objectW, objectH;
	for(; i < NUM_CINTAS; ++i){
		//Desde el punto de vista del jugador
		if (cintas[i]->inMap == 1 && cintas[i]->locationMap == prota->locationMap && cintas[i]->floor == prota->floor)//Si existe la cinta en el mapa
		{

			if(cintas[i]->cola){
				objectH=G_COLA_H;
				objectW=G_COLA_W;
			}
			else{
				objectW=G_OBJETO_0_W;
				objectH=G_OBJETO_0_H;
			}
			
			if(cintas[i]->arriba == prota->arriba){

				//Si me aproximo por la derecha
				if(cintas[i]->x+ objectW < prota->x){
					x= NO;
				}
				//Si me aproximo por la izquierda
				if(cintas[i]->x > prota->x+ G_SPRITESJUGADORES_1_W){
					x= NO;
				}
				//Si me aproximo por debajo
				if(cintas[i]->y+ objectH < prota->y){
					y= NO;
				}
				//Si me aproximo por encima
				if(cintas[i]->y > prota->y+ G_SPRITESJUGADORES_1_H){
					y= NO;
				}

				if(x&&y){//Si estoy dentro de las coordenadas de la cinta
					borrarObjeto(cintas[i],mapa);//Se borra la cinta del mapa
					cintas[i]->inMap = 0;//Se elimina la cinta del mapa
					if(cintas[i]->cola){
						if(prota->energy < 5){
							++prota->energy;
						}
					}
					else{
						TCinta aux;
						prota->cintas++;//Se añade la cinta a recogidas
						aux.sprite = cintas[i]->sprite; //copio el sprite de la cinta
						aux.inMap = cintas[i]->inMap; //copio si esta in map esto solo es por seguridad
						aux.cola = 0;   //pongo que es una cinta
						if(i > 3){
						aux.x = 135+((objectW*(i-4))+(2*(i-4))); // pongo la x en el auxilar
						aux.y = 0; //pongo la y en el auxiliar 
						}else{
						aux.x = 135+((objectW*i)+(2*i)); // pongo la x en el auxilar
						aux.y = 13; //pongo la y en el auxiliar 
						}
						
						dibujarObjeto(&aux); //lo dibujo en la nueva posicion mantentiendo la cinta en su posicion
						//cintas[i]->x = 135+((objectW*i)+(2*i));
						//cintas[i]->y = 13;
						//dibujarObjeto(cintas[i]);
					}
				}
				else{
					x=y=SI;
				}
			}
		}
	}
}

//Devuelve SI en caso de que el jugador esté tocando al enemigo y NO en el caso contrario
u8 enContactoEnemigo(TJugador* prota,Tenemy* enemigos[NUM_ENEMIGOS_NIVEL],u8* mapa){
	u8 i=0, x=SI,y=SI;

	for(; i< NUM_ENEMIGOS_NIVEL;++i){
		if(enemigos[i]->arriba == prota->arriba && enemigos[i]->floor == prota->floor){
		if(enemigos[i]->locationMap != prota->locationMap){
			x = NO;
			y = NO;
		}
		//Si me aproximo por la derecha
		if(enemigos[i]->x+ G_SPRITESENEMIGO_W < prota->x){
			x = NO;
		}
		//Si me aproximo por la izquierda
		if(enemigos[i]->x > prota->x+ G_SPRITESJUGADORES_1_W){
			x = NO;
		}
		//Si me aproximo por debajo
		if(enemigos[i]->y+ G_SPRITESENEMIGO_H < prota->y){
			y = NO;
		}
		//Si me aproximo por encima
		if(enemigos[i]->y > prota->y+ G_SPRITESJUGADORES_1_H){
			y = NO;
		}

		if(x && y){//Si está en el X y en el Y
			animacionPerdido(prota,enemigos[i],mapa);
			return SI;
		}
		else{
			x=y=SI;
		}
	}
	}

	return NO;
}

//Devuelve SI en caso de que el jugador esté tocando al CPC y NO en el caso contrario
u8 enContactoCPC(TJugador* prota){
	u8 x=SI,y=SI;

	if( prota->locationMap != 2 && prota->floor != NUMPLANTAS){
		x = NO;
		y = NO;
	}
	//Si me aproximo por la derecha
	if(POSXCPC + G_CPC_W < prota->x){
		x = NO;
	}
	//Si me aproximo por la izquierda
	if(POSXCPC > prota->x+ G_SPRITESJUGADORES_1_W){
		x = NO;
	}
	//Si me aproximo por debajo
	if(POSYCPC+ G_CPC_H < prota->y){
		y = NO;
	}
	//Si me aproximo por encima
	if(POSYCPC > prota->y+ G_SPRITESJUGADORES_1_H){
		y = NO;
	}

	if(x && y){//Si está en el X y en el Y
		return SI;
	}
	return NO;
}
u8 enContactoEscalera(TJugador* prota){
	u8 x=SI,y=SI;

	if( prota->locationMap != 2){
		x = NO;
		y = NO;
	}
	//Si me aproximo por la derecha
	if(POSXES + G_ESCALERAS_W < prota->x){
		x = NO;
	}
	//Si me aproximo por la izquierda
	if(POSXES > prota->x+ G_SPRITESJUGADORES_1_W){
		x = NO;
	}
	//Si me aproximo por debajo
	if(POSYES+ G_ESCALERAS_H < prota->y){
		y = NO;
	}
	//Si me aproximo por encima
	if(POSYES > prota->y+ G_SPRITESJUGADORES_1_H){
		y = NO;
	}

	if(x && y){//Si está en el X y en el Y
		return SI;
	}
	return NO;
}


u8* obtenerTilePtr(u8 x, u8 y, u8* mapa) {
   return mapa + (y-ORIGEN_MAPA_Y)/4*g_map1_W + x/2;
}

//Comprobación de que no se nos salen de las paredes
u8 comprobarMovimentoLeft(TJugador* prota,u8* mapa){
	u8* tileSuelo = obtenerTilePtr(prota->x-1, prota->y,mapa);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtr(prota->x-1, prota->y+G_SPRITESJUGADORES_1_H-1,mapa);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
		return 0;
	}
}

u8 comprobarMovimentoRight(TJugador* prota, u8* mapa){
	u8* tileSuelo = obtenerTilePtr(prota->x+G_SPRITESJUGADORES_1_W, prota->y,mapa);
	if(*tileSuelo == PARED){
		 u8* aux = obtenerTilePtr(prota->x+G_SPRITESJUGADORES_1_W, prota->y+G_SPRITESJUGADORES_1_H-1,mapa);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
  	  return 0;
	}
}

u8 comprobarMovimentoUp(TJugador* prota, u8* mapa){
	u8* tileSuelo = obtenerTilePtr(prota->x, prota->y-2,mapa);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtr(prota->x+G_SPRITESJUGADORES_1_W-1, prota->y-2,mapa);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
	    return 0;
	}
}

u8 comprobarMovimentoDown(TJugador* prota, u8* mapa){
	u8* tileSuelo = obtenerTilePtr(prota->x, prota->y+G_SPRITESJUGADORES_1_H+1,mapa);
	if(*tileSuelo == PARED){
		u8* aux = obtenerTilePtr(prota->x+G_SPRITESJUGADORES_1_W-1, prota->y+G_SPRITESJUGADORES_1_H,mapa);
		if(*aux == PARED){
			return 1;
		}
		else{
			return 0;
		}

	}else{
    	return 0;
	}
}
/*void enContactoCintaEnemigo(TCinta* cintas[NUM_CINTAS],Tenemy* enemy, u8* mapa){
	u8 i=0;
	u8 x=SI, y =SI;//Los ejes X e Y se inicializan a ocupado
	u8 objectW, objectH;
	for(; i < NUM_CINTAS; ++i){
		//Desde el punto de vista del jugador
		if (cintas[i]->inMap == 1 && cintas[i]->locationMap == enemy->locationMap && cintas[i]->floor == enemy->floor)//Si existe la cinta en el mapa
		{

			if(cintas[i]->cola){
				objectH=G_COLA_H;
				objectW=G_COLA_W;
			}
			else{
				objectW=G_OBJETO_0_W;
				objectH=G_OBJETO_0_H;
			}
			
			if(cintas[i]->arriba == enemy->arriba){

				//Si me aproximo por la derecha
				if(cintas[i]->x+ objectW < enemy->x){
					x= NO;
				}
				//Si me aproximo por la izquierda
				if(cintas[i]->x > enemy->x+ G_SPRITESJUGADORES_1_W){
					x= NO;
				}
				//Si me aproximo por debajo
				if(cintas[i]->y+ objectH < enemy->y){
					y= NO;
				}
				//Si me aproximo por encima
				if(cintas[i]->y > enemy->y+ G_SPRITESJUGADORES_1_H){
					y= NO;
				}

				if(x&&y){//Si estoy dentro de las coordenadas de la cinta
					dibujarObjeto(cintas[i]);
					dibujarEnemigo(enemy);
					/*borrarObjeto(cintas[i],mapa);//Se borra la cinta del mapa
					cintas[i]->inMap = 0;//Se elimina la cinta del mapa
					if(cintas[i]->cola){
						if(prota->energy < 5){
							++prota->energy;
						}
					}
					else{
						TCinta aux;
						prota->cintas++;//Se añade la cinta a recogidas
						aux.sprite = cintas[i]->sprite; //copio el sprite de la cinta
						aux.inMap = cintas[i]->inMap; //copio si esta in map esto solo es por seguridad
						aux.cola = 0;   //pongo que es una cinta
						if(i > 3){
						aux.x = 135+((objectW*(i-4))+(2*(i-4))); // pongo la x en el auxilar
						aux.y = 0; //pongo la y en el auxiliar 
						}else{
						aux.x = 135+((objectW*i)+(2*i)); // pongo la x en el auxilar
						aux.y = 13; //pongo la y en el auxiliar 
						}
						
						dibujarObjeto(&aux); //lo dibujo en la nueva posicion mantentiendo la cinta en su posicion
						//cintas[i]->x = 135+((objectW*i)+(2*i));
						//cintas[i]->y = 13;
						//dibujarObjeto(cintas[i]);
					}
				}
				else{
					x=y=SI;
				}
			}
		}
	}
}*/
//imputs
void comprobarTeclado(TJugador* prota,u8** mapa, TCinta* cintas[NUM_CINTAS],TCinta* colas[NUM_CINTAS], Tenemy* enemigos[NUM_ENEMIGOS_NIVEL]) {

	cpct_scanKeyboard_if();

	if(cpct_isAnyKeyPressed()){
		if(cpct_isKeyPressed(teclas.left)){
			moveLeft(prota,mapa,cintas,colas,enemigos);
		}
		if(cpct_isKeyPressed(teclas.right)){
			moveRight(prota,mapa,cintas,colas,enemigos);
		}
		if(cpct_isKeyPressed(teclas.up)){
			moveUp(prota,*mapa);
		}
		if(cpct_isKeyPressed(teclas.down)){
			moveDown(prota,*mapa);
		}
		if(cpct_isKeyPressed(teclas.invi)){
			invisible(prota);
		}
		

	}
}


