//-----------------------------LICENSE NOTICE------------------------------------
//
// This file is part of Firewall Wars.
//
//    FirewallWars is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License.
// 
//     FirewallWars is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with FirewallWars.  If not, see <http://www.gnu.org/licenses/>.
// 
//------------------------------------------------------------------------------
#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <types.h>
#include "enemy.h"
//Defines
#define PARED 0
#define NO 0
#define SI 1
#define NUM_MAPAS 3
#define ANCHO_PANTALLA 80
#define ALTO_PANTALLA  192
#define NUM_CINTAS 8
#define NUM_ENEMIGOS_NIVEL 8
#define G_OBJETO_W G_OBJETO_0_W
#define G_OBJETO_H G_OBJETO_0_H
#define LIMITE_DERECHO ANCHO_PANTALLA - G_SPRITESJUGADORES_1_W
#define LIMITE_INFERIOR ALTO_PANTALLA - G_SPRITESJUGADORES_1_H
#define NUMPLANTAS 1
#define POSXCPC 57
#define POSYCPC 110
#define POSXES 57
#define POSYES 110

//estructura tiempo
typedef struct Time Time;
struct Time{
   u8 minutes ;
   u8 seconds ;
   u8 cicles  ;
   };

typedef struct {
   u8 	x,y;           //Posicion actual del prota
   u8	   px,py;         //posicion anterior del prota
   const u8* 	sprite;  //Direccion de memoria del sprite del prota
   u8    mover;         //Dice si se ha movido o no el prota
   u8 	vida;          //Almacena el numero de vidas
   u8 	cintas;        //Almacena el numero de cintas
   u8    state;         //Almacena el estado 0 visible 1 invisible 
   u8    locationMap;   //indica en que mapa se encuentra el prota
   u8    energy;        //almacena la energia del jugador
   u8    arriba;        //si esta a 1 esta en los mapas aarriba si esta a 0 esta en los de abajo  
   u8    cicles;        //cantidad de ciclos que se han consumido de la bateria 
   u8    floor;         //la planta del edificio donde esta

} TJugador;

typedef struct{
	u8  x,y;
	u8  inMap; 	         //esta se incia a 1 si esta en el mapa o 0 si la han recogido
	const u8* sprite;
	u8  locationMap;     //indica en que mapa se encuentra la cinta
   u8  arriba;          //si esta a 1 esta en los mapas aarriba si esta a 0 esta en los de abajo 
   u8  cola;            //Estará a 1 si el objeto es una coca cola de recarga y a 0 si es una cinta
   u8  floor;            //Indica el piso en el que se encuentra, si el 0 o el 1
} TCinta;

typedef struct{
   cpct_keyID up;       //Almacena la tecla de arriba
   cpct_keyID left;     //Almacena la tecla de la izquierda
   cpct_keyID down;     //Almacena la tecla de abajo
   cpct_keyID right;    //Almacena la tecla de la derecha
   cpct_keyID restart;  //Almacena la tecla de reinicio
   cpct_keyID invi;     //Almacena la tecla de invisibilidad
}TTeclas;

void moveRight(TJugador*,u8**,TCinta*[NUM_CINTAS],TCinta*[NUM_CINTAS],Tenemy* [NUM_ENEMIGOS_NIVEL]);
void moveLeft(TJugador*,u8**,TCinta*[NUM_CINTAS],TCinta*[NUM_CINTAS],Tenemy* [NUM_ENEMIGOS_NIVEL]);
void moveUp(TJugador*,u8*);
void moveDown(TJugador*,u8*);
u8 enContactoCPC(TJugador* prota);
u8 enContactoEscalera(TJugador* prota);
void comprobarTeclado(TJugador*,u8**,TCinta* [NUM_CINTAS],TCinta*[NUM_CINTAS],Tenemy* [NUM_ENEMIGOS_NIVEL]);
void enContactoCinta(TCinta*[NUM_CINTAS],TJugador*,u8*);
u8 enContactoEnemigo(TJugador*,Tenemy* [NUM_ENEMIGOS_NIVEL],u8*);
u8 comprobarMovimentoLeft(TJugador*,u8*);
u8 comprobarMovimentoUp(TJugador*,u8*);
u8 comprobarMovimentoRight(TJugador*,u8*);
u8 comprobarMovimentoDown(TJugador*,u8*);
u8* obtenerTilePtr(u8 x, u8 y,u8*);
//void enContactoCintaEnemigo(TCinta* cintas[NUM_CINTAS],Tenemy* enemy, u8* mapa);
void avanzarMapa(TJugador*,u8**,TCinta*[NUM_CINTAS],TCinta*[NUM_CINTAS],Tenemy* [NUM_ENEMIGOS_NIVEL]);
void retrocerMapa(TJugador*,u8**,TCinta*[NUM_CINTAS],TCinta*[NUM_CINTAS],Tenemy* [NUM_ENEMIGOS_NIVEL]);

#endif